      SUBROUTINE PARINI
      IMPLICIT REAL*8 (A-H,O-Z)
      INCLUDE 'MAX.INC'
      INCLUDE 'LLSQDAT.INC'
      INCLUDE 'PAREQ.INC'
      DO 10 I=1,MAXPAR
      PAR(I)=0
   10 STEP(I)=0.00001
C      OPEN(FILE='PAROLD.DAT',UNIT=25,FORM='UNFORMATTED')
C      READ(25)PAR
C      CLOSE (25)
      NPAR=1
      ZER_CONST=0.13405D0
      ZER_LEN=0.0547D0
      ZER_DIAM=0.733D0
      DO 30 I=1,MAXPAR
   30 STEP(I)=0.000001*(ABS(PAR(I))+0.1)
      RETURN
      END


      FUNCTION ZERFQ(X,D)
      IMPLICIT REAL*8 (A-H,O-Z)
      INCLUDE 'MAX.INC'
      INCLUDE 'LLSQDAT.INC'
      INCLUDE 'PAREQ.INC'
C ********** FREQUENCY IN CAGE **************
C This routine estimates the frequency inside the cage for an
C element without any boom tube.
C The input is length and diameter in meters
C *******************************************
      T=(1-ZER_LEN)*X+ZER_DIAM*SQRT(D)+ZER_CONST
      ZERFQ=0.5*CVEL/T
      RETURN
      END



      PROGRAM MAKE_ZERFQ
      IMPLICIT REAL*8 (A-H,O-Z)
      INCLUDE 'MAX.INC'
      INCLUDE 'MINIM.INC'
      INCLUDE 'PAREQ.INC'
      INCLUDE 'LLSQDAT.INC'
      COMMON/SCALE/ICOLOR(32),YSCALE,YZER,XOFF,XSCALE
      CALL PARINI
C Read table of element lengths, diameters and frequencies
      OPEN(FILE='ELEMENT.DAT',UNIT=33)
      NELEM=0
      IC=10
      DO 90 I=1,32
 90   ICOLOR(I)=0
 100  NELEM=NELEM+1
      IF(NELEM.LE.MAXELE)GOTO 101
      WRITE(*,*)'Too many elements in ELEMENT.DAT!'
      STOP
 101  READ(33,605,ERR=110)K,ELDIAM(NELEM),ELLEN(NELEM),ELFRQ(NELEM)
 605  FORMAT(I2,3F10.3)
      IF(K.EQ.0)GOTO 110
      J=ELDIAM(NELEM)+0.5D0
      IF(ICOLOR(J).NE.0)GOTO 102
      ICOLOR(J)=IC
      IC=IC+1
      IF(IC.LE.15)GOTO 102
      WRITE(*,*)'TOO MANY ELEMENT DIAMETERS'
      STOP
 102  IF(K.EQ.NELEM)GOTO 100
      WRITE(*,*)'Elements not in correct order in ELEMENT.DAT!'
      STOP
 110  CLOSE (33)
      NELEM=NELEM-1
      IF(NPAR.EQ.0)GOTO 1099
      ALFA=0.000001
      ALFMIN=ALFA
      NIT=0
      IDIR=1
      SUM=0
 1000 CONTINUE
      SUMOLD=SUM
      NIT=NIT+1
      CALL CALC(0)
      T=0
      SUM=SQSUM
      IDIR=-IDIR
      TOTSUM=0
      DO 4100 NN=1,NPAR
      PAR(NN)=PAR(NN)+STEP(NN)*IDIR
      CALL CALC(NN)
      PAR(NN)=PAR(NN)-STEP(NN)*IDIR
 4100 CONTINUE
      DO 4200 I=1,NPAR
      NEQ=NEQ+1
      BARB(NEQ)=0
      DO 4300 J=1,NPAR
 4300 DER(J,NEQ)=0
 4200 DER(I,NEQ)=ALFA
      CALL LLSQ
 677  FORMAT(I4,F20.14,2F12.8)
      DO 5000 I=1,NPAR
 5000 PAR(I)=PAR(I)-UPU(I)*STEP(I)*IDIR
      WRITE(*,677)NIT,SUM,ALFA*100000,PAR(1)
      IF(NIT.EQ.1)GOTO 1000
      ALFA=ALFA*.95
      IF(SUM.GT.SUMOLD)ALFA=ALFA*2
      IF(ALFA.LT.ALFMIN)ALFMIN=ALFA
      IF(NIT.LT.1000.AND.ALFA.LT.8*ALFMIN)GOTO 1000
      DO 2030 I=1,NPAR
 2030 WRITE(*,*)I,PAR(I)
      OPEN(FILE='PARNEW.DAT',UNIT=26,FORM='UNFORMATTED')
      WRITE(26)PAR
      CLOSE (26)
      WRITE(*,*)'PRESS ENTER'
      READ(*,611)DUM
 611  FORMAT(F1.1)
 1099 CONTINUE
      OPEN(FILE='FIT.DAT',UNIT=27)
      CALL CALC(-1)
      CLOSE (27)
      CALL FIG
      SQSUM=SQSUM/NEQ
      WRITE(*,655)SQRT(SQSUM)
 655  FORMAT('RMS ERROR=',F9.4,' MHz')
      STOP
      END

      SUBROUTINE CALC(NN)
      IMPLICIT REAL*8 (A-H,O-Z)
      INCLUDE 'MAX.INC'
      INCLUDE 'LLSQDAT.INC'
      INCLUDE 'MINIM.INC'
      INCLUDE 'PAREQ.INC'
      SQSUM=0
      NEQ=0
      DO 200 I=1,NELEM
      NEQ=NEQ+1
      IF(NEQ.GT.MAXEQ)GOTO 99
C Calculate the frequency of a rod as a function of length and diameter.
      FQ=ELFRQ(I)
      X=0.001*ELLEN(I)
      D=0.001*ELDIAM(I)
      T1=ZERFQ(X,D)-FQ
      T=T1**2
      SQSUM=SQSUM+T
      IF(NN.LT.0)GOTO 190
      IF(NN.EQ.0)THEN
        BARB(NEQ  )=T1
      ELSE
        DER(NN,NEQ  )=T1-BARB(NEQ  )
      ENDIF
      GOTO 200
 190  CONTINUE
      TEO(I)=T1+FQ
      WRITE(27,627)ELLEN(I),ELDIAM(I),ELFRQ(I),T1
 627  FORMAT(8F8.3)
 200  CONTINUE
      RETURN
 99   WRITE(*,*)'TOO MANY EQUATIONS'
      STOP
      END

      SUBROUTINE CROSS(X,Y,KD)
      IMPLICIT REAL*8 (A-H,O-Z)
      INCLUDE 'MAX.INC'
      INCLUDE 'LLSQDAT.INC'
      INCLUDE 'MINIM.INC'
      INCLUDE 'PAREQ.INC'
      INCLUDE '\WATCOM\H\GRAPHAPI.FI'
      INCLUDE '\WATCOM\H\GRAPH.FI'
      COMMON/SCALE/ICOLOR(32),YSCALE,YZER,XOFF,XSCALE
      IX=(X-XOFF)*XSCALE
      IY=Y*YSCALE+YZER
      IF(KD.EQ.0)GOTO 100
      IF(KD.EQ.1)GOTO 200
      CALL _MOVETO(IX+2,IY+2)
      CALL _LINETO(IX-2,IY-2)
      CALL _MOVETO(IX-2,IY+2)
      CALL _LINETO(IX+2,IY-2)
      RETURN
 100  CALL _MOVETO(IX+4,IY)
      CALL _LINETO(IX-4,IY)
      CALL _MOVETO(IX+4,IY+1)
      CALL _LINETO(IX-4,IY+1)
      CALL _MOVETO(IX+4,IY-1)
      CALL _LINETO(IX-4,IY-1)
      CALL _MOVETO(IX,IY+4)
      CALL _LINETO(IX,IY-4)
      CALL _MOVETO(IX+1,IY+4)
      CALL _LINETO(IX+1,IY-4)
      CALL _MOVETO(IX-1,IY+4)
      CALL _LINETO(IX-1,IY-4)
      RETURN
 200  CALL _MOVETO(IX+4,IY+4)
      CALL _LINETO(IX-4,IY-4)
      CALL _MOVETO(IX-4,IY+4)
      CALL _LINETO(IX+4,IY-4)
      CALL _MOVETO(IX+7,IY+4)
      CALL _LINETO(IX-5,IY-4)
      CALL _MOVETO(IX-5,IY+4)
      CALL _LINETO(IX+7,IY-4)
      CALL _MOVETO(IX+5,IY+4)
      CALL _LINETO(IX-7,IY-4)
      CALL _MOVETO(IX-7,IY+4)
      CALL _LINETO(IX+5,IY-4)
      RETURN
      END


      SUBROUTINE FIG
      IMPLICIT REAL*8 (A-H,O-Z)
      INCLUDE 'MAX.INC'
      INCLUDE 'LLSQDAT.INC'
      INCLUDE 'MINIM.INC'
      INCLUDE 'PAREQ.INC'
      INCLUDE '\WATCOM\H\GRAPHAPI.FI'
      INCLUDE '\WATCOM\H\GRAPH.FI'
      CHARACTER*6 A
      COMMON/SCALE/ICOLOR(32),YSCALE,YZER,XOFF,XSCALE
      YSCALE=1000
      YZER=383
      XOFF=0
      XSCALE=0.5
      CALL _SETVIDEOMODE(_XRES16COLOR)
      CALL _SETCOLOR(7)
      CALL _MOVETO(0,INT(YZER))
      CALL _LINETO(1023,INT(YZER))
      CALL _SETTEXTPOSITION(3,3)
      DO 100 I=1,32
      IF(ICOLOR(I).EQ.0)GOTO 100
      CALL _SETTEXTCOLOR(ICOLOR(I))
      WRITE(A,602)I
 602  FORMAT(' ',I2,' ')
      CALL _OUTTEXT(A)
 100  CONTINUE
      DO 200 I=1,NELEM
      J=ELDIAM(I)+0.5D0
      CALL _SETCOLOR(ICOLOR(J))
      CALL _SETPLOTACTION(_GPSET)
      CALL CROSS(ELLEN(I),ELFRQ(I)-TEO(I),0)
 200  CONTINUE
      READ(*,611)DUM
 611  FORMAT(F1.1)
      CALL_SETVIDEOMODE(-1)
      RETURN
      END

